Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 687668 - sys-apps/portage: --autounmask-backtrack=n prevents triggering of slot operator rebuilds when old subslot is masked and triggers autounmask
Summary: sys-apps/portage: --autounmask-backtrack=n prevents triggering of slot operat...
Status: CONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Unclassified (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: autounmask
  Show dependency tree
 
Reported: 2019-06-09 00:38 UTC by William Throwe
Modified: 2019-09-06 21:20 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description William Throwe 2019-06-09 00:38:40 UTC
When upgrading a package that triggers subslot rebuilds, portage tries to use binary packages for the rebuilds even if they are built against the wrong subslot.  This results in errors due to multiple versions of the requested package being pulled in (including a masked package in this case).


# emerge '=perl-5.28.2-r1' -p --ignore-default-opts --usepkg

These are the packages that would be merged, in order:

Calculating dependencies... done!
[binary  r  UD#] dev-lang/perl-5.24.3-r1-1 [5.26.2]
[binary  rR    ] perl-core/File-Temp-0.230.400-r1-1 
[binary  rR    ] virtual/perl-File-Temp-0.230.400-r5-1 
[binary  rR    ] dev-perl/TimeDate-2.300.0-1 
[ebuild  r  U  ] dev-lang/perl-5.28.2-r1 [5.26.2]
[ebuild  N     ] virtual/perl-File-Path-2.150.0 
[ebuild  r  U  ] virtual/perl-Test-Harness-3.420.0-r1 [3.380.0]
[ebuild  r  U  ] virtual/perl-Data-Dumper-2.170.0 [2.167.0]
[ebuild  r  U  ] virtual/perl-Scalar-List-Utils-1.500.0-r1 [1.460.200_rc]
[ebuild  r  U  ] virtual/perl-Digest-SHA-6.10.0 [5.960.0]
[ebuild  r  U  ] virtual/perl-IO-1.390.0 [1.380.0]
[ebuild  r  U  ] virtual/perl-libnet-3.110.0-r1 [3.100.0]
[binary  rR    ] dev-perl/Error-0.170.250-1 
[binary  rR    ] dev-perl/MailTools-2.190.0-1 
[ebuild  rR    ] dev-lang/perl-5.26.2 
[binary  r  U  ] virtual/perl-Digest-MD5-2.550.0-r1-1 [2.550.0]
[binary  rR    ] dev-perl/Digest-HMAC-1.30.0-r1-1 
[binary  rR    ] dev-perl/Authen-SASL-2.160.0-r1-1 
[ebuild  rR    ] dev-vcs/git-2.21.0 

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/perl:0

  (dev-lang/perl-5.28.2-r1:0/5.28::gentoo, ebuild scheduled for merge) pulled in by
    =dev-lang/perl-5.28.2-r1 (Argument)
    =dev-lang/perl-5.28* required by (virtual/perl-Digest-SHA-6.10.0:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                            
    (and 16 more with the same problems)

  (dev-lang/perl-5.24.3-r1-1:0/5.24::gentoo, binary scheduled for merge) pulled in by
    dev-lang/perl:0/5.24= required by (dev-perl/MailTools-2.190.0-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                       
    (and 13 more with the same problem)

  (dev-lang/perl-5.26.2:0/5.26::gentoo, ebuild scheduled for merge) pulled in by
    dev-lang/perl:0/5.26= required by (virtual/perl-Digest-MD5-2.550.0-r1-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                               
    (and 1 more with the same problem)

NOTE: Use the '--verbose-conflicts' option to display parents omitted above

It may be possible to solve this problem by using package.mask to
prevent one of those packages from being selected. However, it is also
possible that conflicting dependencies exist such that they are
impossible to satisfy simultaneously.  If such a conflict exists in
the dependencies of two different packages, then those packages can
not be installed simultaneously.

For more information, see MASKED PACKAGES section in the emerge man
page or refer to the Gentoo Handbook.


The following packages are causing rebuilds:

  (dev-lang/perl-5.24.3-r1-1:0/5.24::gentoo, binary scheduled for merge) causes rebuilds for:
    (dev-perl/TimeDate-2.300.0-1:0/0::gentoo, binary scheduled for merge)
    (virtual/perl-Digest-SHA-6.10.0:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-File-Temp-0.230.400-r5-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/Error-0.170.250-1:0/0::gentoo, binary scheduled for merge)
    (perl-core/File-Temp-0.230.400-r1-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/Authen-SASL-2.160.0-r1-1:0/0::gentoo, binary scheduled for merge)
    (virtual/perl-Test-Harness-3.420.0-r1:0/0::gentoo, ebuild scheduled for merge)
    (dev-perl/MailTools-2.190.0-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/Digest-HMAC-1.30.0-r1-1:0/0::gentoo, binary scheduled for merge)
    (virtual/perl-Scalar-List-Utils-1.500.0-r1:0/0::gentoo, ebuild scheduled for merge)
  (dev-lang/perl-5.28.2-r1:0/5.28::gentoo, ebuild scheduled for merge) causes rebuilds for:
    (virtual/perl-Digest-SHA-6.10.0:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-Digest-MD5-2.550.0-r1-1:0/0::gentoo, binary scheduled for merge)
    (virtual/perl-IO-1.390.0:0/0::gentoo, ebuild scheduled for merge)
    (dev-vcs/git-2.21.0:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-Data-Dumper-2.170.0:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-libnet-3.110.0-r1:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-Test-Harness-3.420.0-r1:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-Scalar-List-Utils-1.500.0-r1:0/0::gentoo, ebuild scheduled for merge)

!!! The following binary packages have been ignored due to non matching USE:

    =sys-devel/gettext-0.19.8.1 emacs
    =virtual/libiconv-0-r2 abi_x86_32

NOTE: The --binpkg-respect-use=n option will prevent emerge
      from ignoring these binary packages if possible.
      Using --binpkg-respect-use=y will silence this warning.

The following mask changes are necessary to proceed:
 (see "package.unmask" in the portage(5) man page for more details)
# required by dev-perl/Digest-HMAC-1.30.0-r1::gentoo
# required by dev-perl/Authen-SASL-2.160.0-r1::gentoo
# required by dev-vcs/git-2.21.0::gentoo[perl]
# required by @__auto_slot_operator_replace_installed__ (argument)
# /usr/portage/profiles/package.mask:
# Andreas K. Hüttel <dilfridge@gentoo.org> (11 May 2019)
# Perl 5.24 will be removed soon. Please upgrade.
=dev-lang/perl-5.24.3-r1

NOTE: The --autounmask-keep-masks option will prevent emerge
      from creating package.unmask or ** keyword changes.

 * In order to avoid wasting time, backtracking has terminated early
 * due to the above autounmask change(s). The --autounmask-backtrack=y
 * option can be used to force further backtracking, but there is no
 * guarantee that it will produce a solution.


# emerge --info
Portage 2.3.66 (python 3.6.5-final-0, default/linux/amd64/17.1, gcc-7.3.0, glibc-2.29-r2, 4.14.83-gentoo x86_64)
=================================================================
System uname: Linux-4.14.83-gentoo-x86_64-Intel-R-_Xeon-R-_CPU_E5-2620_v4_@_2.10GHz-with-gentoo-2.6
KiB Mem:    32883248 total,  12657004 free
KiB Swap:   67108856 total,  66487720 free
Timestamp of repository gentoo: Sat, 08 Jun 2019 23:30:02 +0000
Head commit of repository gentoo: 7d211604cc83b15d4aed3dc0f04edc6c3201c86f
sh bash 4.4_p23-r1
ld GNU ld (Gentoo 2.31.1 p7) 2.31.1
app-shells/bash:          4.4_p23-r1::gentoo
dev-java/java-config:     2.2.0-r4::gentoo
dev-lang/perl:            5.26.2::gentoo
dev-lang/python:          2.7.15::gentoo, 3.6.5::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/openrc:          0.41.2::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.16.1-r1::gentoo
sys-devel/binutils:       2.31.1-r6::gentoo
sys-devel/gcc:            7.3.0-r3::gentoo, 8.2.0-r6::gentoo, 8.3.0-r1::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.14-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.29-r2::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-max-age: 24
    sync-rsync-extra-opts: 
    sync-rsync-verify-metamanifest: yes

wthrowe-misc
    location: /usr/local/shared/feanor/overlays/wthrowe-misc
    masters: gentoo
    priority: 0

wthrowe-multilib
    location: /usr/local/shared/feanor/overlays/wthrowe-multilib
    masters: gentoo
    priority: 1

crossdev
    location: /usr/local/shared/feanor/overlays/portage-crossdev
    masters: gentoo
    priority: 10

barnowl
    location: /var/lib/layman/barnowl
    masters: gentoo
    priority: 50

sxs-spectre
    location: /var/lib/layman/sxs-spectre
    masters: gentoo
    priority: 50

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="@FREE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe -ggdb"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -O2 -pipe -ggdb"
DISTDIR="/var/cache/distfiles"
EMERGE_DEFAULT_OPTS="--ask --quiet-build=n --autounmask-write=n --usepkg --with-bdeps=n --backtrack=100 --binpkg-respect-use=y --binpkg-changed-deps=n"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs binpkg-multi-instance buildpkg clean-logs compress-build-logs compressdebug config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned sandbox sfperms split-log splitdebug strict unknown-features-warn unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="POSIX"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu"
MAKEOPTS="-j24"
PKGDIR="/var/cache/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="acl amd64 bindist bzip2 cli crypt cxx dri fortran iconv ipv6 libtirpc multilib ncurses nls nptl openmp pam pcre readline seccomp ssl tcpd unicode xattr zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 fma3 mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-2" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="amdgpu fbdev intel nouveau radeon radeonsi vesa dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Zac Medico gentoo-dev 2019-06-09 22:27:24 UTC
(In reply to William Throwe from comment #0)
> When upgrading a package that triggers subslot rebuilds, portage tries to
> use binary packages for the rebuilds even if they are built against the
> wrong subslot.  This results in errors due to multiple versions of the
> requested package being pulled in (including a masked package in this case).
> 
> 
> # emerge '=perl-5.28.2-r1' -p --ignore-default-opts --usepkg

A command like 'emerge -uD --usepkg @world' will generally work better, at least until the --rebuild-if-conflict option discussed in bug 672914 is implemented. Also, maybe a higher --backtrack parameter would solve it.
Comment 2 William Throwe 2019-06-09 23:25:53 UTC
Using "emerge -uD --usepkg @world --backtrack 1000" still tries to pull in both dev-lang/perl-5.24.3-r1 and dev-lang/perl-5.28.2-r1.
Comment 3 Zac Medico gentoo-dev 2019-06-10 00:37:11 UTC
(In reply to William Throwe from comment #2)
> Using "emerge -uD --usepkg @world --backtrack 1000" still tries to pull in
> both dev-lang/perl-5.24.3-r1 and dev-lang/perl-5.28.2-r1.

Please post output with --verbose-conflicts.
Comment 4 William Throwe 2019-06-10 01:14:15 UTC
# /usr/bin/emerge --ignore-default-opts -p -uD --usepkg @world --backtrack 1000 --verbose-conflicts
These are the packages that would be merged, in order:

Calculating dependencies... done!
[binary     U  ] sys-apps/man-pages-5.00-1 [4.16]
[ebuild     U  ] app-admin/eselect-1.4.14 [1.4.13]
[binary     U  ] dev-python/pyopenssl-19.0.0-1 [17.5.0]
[binary  r  UD#] dev-lang/perl-5.24.3-r1-1 [5.26.2]
[binary  rR    ] dev-perl/TimeDate-2.300.0-1 
[binary  rR    ] perl-core/File-Temp-0.230.400-r1-1 
[binary  rR    ] virtual/perl-File-Temp-0.230.400-r5-1 
[ebuild  r  U  ] dev-lang/perl-5.28.2-r1 [5.26.2]
[ebuild  N     ] virtual/perl-File-Path-2.150.0 
[ebuild     U  ] virtual/perl-Test-Harness-3.420.0-r1 [3.380.0]
[ebuild     U  ] virtual/perl-Data-Dumper-2.170.0 [2.167.0]
[ebuild     U  ] virtual/perl-Digest-SHA-6.10.0 [5.960.0]
[ebuild     U  ] virtual/perl-Digest-MD5-2.550.0-r1 [2.550.0]
[ebuild     U  ] virtual/perl-libnet-3.110.0-r1 [3.100.0]
[ebuild     U  ] virtual/perl-IO-1.390.0 [1.380.0]
[ebuild     U  ] virtual/perl-Scalar-List-Utils-1.500.0-r1 [1.460.200_rc]
[binary  rR    ] dev-perl/Digest-HMAC-1.30.0-r1-1 
[binary  rR    ] dev-perl/MailTools-2.190.0-1 
[binary  rR    ] dev-perl/Error-0.170.250-1 
[binary  rR    ] dev-perl/Authen-SASL-2.160.0-r1-1 
[ebuild     U  ] net-misc/curl-7.65.0 [7.64.1]
[ebuild     U  ] app-portage/gemato-14.1 [14.0]
[ebuild  rR    ] dev-vcs/git-2.21.0 
[ebuild     U  ] net-print/cups-2.2.11 [2.2.7]
[binary  N     ] dev-java/icedtea-web-1.6.2-1  USE="-doc -javascript -nsplugin -tagsoup -test" 
[binary     U  ] sys-apps/hwids-20180917-1 [20171003]

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/perl:0

  (dev-lang/perl-5.28.2-r1:0/5.28::gentoo, ebuild scheduled for merge) pulled in by
    =dev-lang/perl-5.28* required by (virtual/perl-Digest-SHA-6.10.0:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                            
    =dev-lang/perl-5.28* required by (virtual/perl-Digest-MD5-2.550.0-r1:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                                
    =dev-lang/perl-5.28* required by (virtual/perl-IO-1.390.0:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                     
    =dev-lang/perl-5.28* required by (virtual/perl-Data-Dumper-2.170.0:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                              
    =dev-lang/perl-5.28* required by (virtual/perl-libnet-3.110.0-r1:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                            
    =dev-lang/perl-5.28* required by (virtual/perl-Scalar-List-Utils-1.500.0-r1:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                                       
    =dev-lang/perl-5.28* required by (virtual/perl-File-Path-2.150.0:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                            
    =dev-lang/perl-5.28* required by (virtual/perl-Test-Harness-3.420.0-r1:0/0::gentoo, ebuild scheduled for merge)
    ^              ^^^^^                                                                                                                                                  

  (dev-lang/perl-5.24.3-r1-1:0/5.24::gentoo, binary scheduled for merge) pulled in by
    dev-lang/perl:0/5.24=[-build(-)] required by (dev-perl/TimeDate-2.300.0-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                                 
    dev-lang/perl:0/5.24=[-build(-)] required by (dev-perl/Authen-SASL-2.160.0-r1-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                                       
    dev-lang/perl:0/5.24= required by (dev-perl/MailTools-2.190.0-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                       
    dev-lang/perl:0/5.24=[-build(-)] required by (dev-perl/Digest-HMAC-1.30.0-r1-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                                      
    dev-lang/perl:0/5.24= required by (dev-perl/Error-0.170.250-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                     
    dev-lang/perl:0/5.24= required by (virtual/perl-File-Temp-0.230.400-r5-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                                
    dev-lang/perl:0/5.24=[-build(-)] required by (perl-core/File-Temp-0.230.400-r1-1:0/0::gentoo, binary scheduled for merge)
                 ^^^^^^^^                                                                                                                                        


It may be possible to solve this problem by using package.mask to
prevent one of those packages from being selected. However, it is also
possible that conflicting dependencies exist such that they are
impossible to satisfy simultaneously.  If such a conflict exists in
the dependencies of two different packages, then those packages can
not be installed simultaneously.

For more information, see MASKED PACKAGES section in the emerge man
page or refer to the Gentoo Handbook.


The following packages are causing rebuilds:

  (dev-lang/perl-5.24.3-r1-1:0/5.24::gentoo, binary scheduled for merge) causes rebuilds for:
    (dev-vcs/git-2.21.0:0/0::gentoo, ebuild scheduled for merge)
    (dev-perl/MailTools-2.190.0-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/Authen-SASL-2.160.0-r1-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/Digest-HMAC-1.30.0-r1-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/Error-0.170.250-1:0/0::gentoo, binary scheduled for merge)
    (virtual/perl-File-Temp-0.230.400-r5-1:0/0::gentoo, binary scheduled for merge)
    (dev-perl/TimeDate-2.300.0-1:0/0::gentoo, binary scheduled for merge)
    (perl-core/File-Temp-0.230.400-r1-1:0/0::gentoo, binary scheduled for merge)

!!! The following binary packages have been ignored due to non matching USE:

    =sys-apps/util-linux-2.33-r1 tty-helpers
    =sys-process/psmisc-23.1-r1 X
    =net-misc/dhcpcd-7.1.1-r3 udev
    =sys-devel/gettext-0.19.8.1 emacs
    =dev-libs/libxml2-2.9.9-r1 icu python
    =app-crypt/pinentry-1.1.0-r2 emacs gtk
    =sys-devel/autoconf-2.69-r4 emacs
    =dev-libs/glib-2.58.3 dbus
    =media-libs/harfbuzz-2.3.1 introspection
    =media-libs/harfbuzz-2.3.1 icu
    =dev-util/desktop-file-utils-0.23 emacs
    =media-fonts/urw-fonts-2.4.9 X
    =sys-libs/pam-1.3.0-r2 filecaps
    =sys-auth/pambase-20150213-r2 consolekit
    =virtual/libiconv-0-r2 abi_x86_32
    =sys-apps/groff-1.22.3 X
    =media-fonts/liberation-fonts-2.00.1-r3 X
    =media-fonts/dejavu-2.37 X
    =dev-lang/python-3.5.5 gdbm sqlite
    =dev-lang/python-3.5.5 sqlite
    =dev-lang/python-3.5.5 tk

NOTE: The --binpkg-respect-use=n option will prevent emerge
      from ignoring these binary packages if possible.
      Using --binpkg-respect-use=y will silence this warning.

!!! The following binary packages have been ignored due to changed dependencies:

     dev-lang/python-3.5.5::gentoo

NOTE: The --binpkg-changed-deps=n option will prevent emerge
      from ignoring these binary packages if possible.
      Using --binpkg-changed-deps=y will silence this warning.

The following mask changes are necessary to proceed:
 (see "package.unmask" in the portage(5) man page for more details)
# required by perl-core/File-Temp-0.230.400-r1::gentoo
# required by virtual/perl-File-Temp-0.230.400-r5::gentoo
# required by dev-lang/perl-5.28.2-r1::gentoo
# required by virtual/perl-Scalar-List-Utils-1.500.0-r1::gentoo
# required by dev-perl/Error-0.170.250::gentoo
# required by dev-vcs/git-2.21.0::gentoo[perl]
# required by @__auto_slot_operator_replace_installed__ (argument)
# /usr/portage/profiles/package.mask:
# Andreas K. Hüttel <dilfridge@gentoo.org> (11 May 2019)
# Perl 5.24 will be removed soon. Please upgrade.
=dev-lang/perl-5.24.3-r1

NOTE: The --autounmask-keep-masks option will prevent emerge
      from creating package.unmask or ** keyword changes.

 * In order to avoid wasting time, backtracking has terminated early
 * due to the above autounmask change(s). The --autounmask-backtrack=y
 * option can be used to force further backtracking, but there is no
 * guarantee that it will produce a solution.
Comment 5 Zac Medico gentoo-dev 2019-06-10 02:12:53 UTC
Does it solve if you add --autounmask-keep-masks to the emerge options?
Comment 6 William Throwe 2019-06-10 02:58:37 UTC
Yes, --autounmask-keep-masks does it.  In fact, even just "--usepkg --autounmask-keep-masks perl" finds a reasonable solution.  Using --autounmask-backtrack=y instead of --autounmask-keep-masks also works.


# /usr/bin/emerge --ignore-default-opts -p -uD --usepkg @world --backtrack 1000 --verbose-conflicts --autounmask-keep-masks

These are the packages that would be merged, in order:

Calculating dependencies... done!
[binary     U  ] sys-apps/man-pages-5.00-1 [4.16]
[ebuild     U  ] app-admin/eselect-1.4.14 [1.4.13]
[binary     U  ] dev-python/pyopenssl-19.0.0-1 [17.5.0]
[ebuild  r  U  ] dev-lang/perl-5.28.2-r1 [5.26.2]
[ebuild     U  ] virtual/perl-Test-Harness-3.420.0-r1 [3.380.0]
[ebuild     U  ] virtual/perl-Data-Dumper-2.170.0 [2.167.0]
[ebuild  N     ] virtual/perl-Parse-CPAN-Meta-2.150.10-r2 
[ebuild  N     ] virtual/perl-CPAN-Meta-YAML-0.18.0-r4 
[ebuild  N     ] virtual/perl-ExtUtils-MakeMaker-7.340.0-r1 
[ebuild  rR    ] perl-core/File-Temp-0.230.400-r1 
[ebuild  rR    ] dev-perl/TimeDate-2.300.0 
[ebuild     U  ] virtual/perl-Digest-SHA-6.10.0 [5.960.0]
[ebuild     U  ] virtual/perl-Digest-MD5-2.550.0-r1 [2.550.0]
[ebuild  N     ] virtual/perl-version-0.992.300 
[ebuild  N     ] virtual/perl-podlators-4.100.0 
[ebuild  N     ] virtual/perl-Text-ParseWords-3.300.0-r5 
[ebuild  N     ] virtual/perl-Perl-OSType-1.10.0-r2 
[ebuild  N     ] virtual/perl-Module-Metadata-1.0.33-r1 
[ebuild     U  ] virtual/perl-Getopt-Long-2.500.0-r1 [2.490.0]
[ebuild     U  ] virtual/perl-File-Spec-3.740.0 [3.670.0]
[ebuild  N     ] virtual/perl-ExtUtils-ParseXS-3.390.0 
[ebuild  N     ] virtual/perl-ExtUtils-Manifest-1.700.0-r5 
[ebuild  N     ] virtual/perl-ExtUtils-Install-2.140.0-r1 
[ebuild  N     ] virtual/perl-ExtUtils-CBuilder-0.280.230 
[ebuild  N     ] virtual/perl-JSON-PP-2.970.10 
[ebuild     U  ] virtual/perl-Scalar-List-Utils-1.500.0-r1 [1.460.200_rc]
[ebuild     U  ] virtual/perl-libnet-3.110.0-r1 [3.100.0]
[ebuild     U  ] virtual/perl-IO-1.390.0 [1.380.0]
[ebuild  rR    ] virtual/perl-File-Temp-0.230.400-r5 
[ebuild  rR    ] dev-perl/Digest-HMAC-1.30.0-r1 
[ebuild  rR    ] dev-perl/MailTools-2.190.0 
[ebuild  N     ] virtual/perl-CPAN-Meta-2.150.10-r2 
[ebuild  rR    ] dev-perl/Authen-SASL-2.160.0-r1 
[ebuild  N     ] dev-perl/Module-Build-0.422.400  USE="-test" 
[ebuild  rR    ] dev-perl/Error-0.170.250 
[ebuild     U  ] net-misc/curl-7.65.0 [7.64.1]
[ebuild     U  ] app-portage/gemato-14.1 [14.0]
[ebuild  rR    ] dev-vcs/git-2.21.0 
[ebuild     U  ] net-print/cups-2.2.11 [2.2.7]
[binary  N     ] dev-java/icedtea-web-1.6.2-1  USE="-doc -javascript -nsplugin -tagsoup -test" 
[binary     U  ] sys-apps/hwids-20180917-1 [20171003]

The following packages are causing rebuilds:

  (dev-lang/perl-5.28.2-r1:0/5.28::gentoo, ebuild scheduled for merge) causes rebuilds for:
    (dev-perl/MailTools-2.190.0:0/0::gentoo, ebuild scheduled for merge)
    (dev-perl/Error-0.170.250:0/0::gentoo, ebuild scheduled for merge)
    (dev-perl/Authen-SASL-2.160.0-r1:0/0::gentoo, ebuild scheduled for merge)
    (perl-core/File-Temp-0.230.400-r1:0/0::gentoo, ebuild scheduled for merge)
    (virtual/perl-File-Temp-0.230.400-r5:0/0::gentoo, ebuild scheduled for merge)
    (dev-vcs/git-2.21.0:0/0::gentoo, ebuild scheduled for merge)
    (dev-perl/TimeDate-2.300.0:0/0::gentoo, ebuild scheduled for merge)
    (dev-perl/Digest-HMAC-1.30.0-r1:0/0::gentoo, ebuild scheduled for merge)

!!! The following binary packages have been ignored due to non matching USE:

    =net-misc/dhcpcd-7.1.1-r3 udev
    =sys-apps/util-linux-2.33-r1 tty-helpers
    =sys-process/psmisc-23.1-r1 X
    =sys-devel/gettext-0.19.8.1 emacs
    =dev-libs/libxml2-2.9.9-r1 icu python
    =app-crypt/pinentry-1.1.0-r2 emacs gtk
    =sys-devel/autoconf-2.69-r4 emacs
    =sys-libs/pam-1.3.0-r2 filecaps
    =sys-auth/pambase-20150213-r2 consolekit
    =dev-libs/glib-2.58.3 dbus
    =media-libs/harfbuzz-2.3.1 introspection
    =media-libs/harfbuzz-2.3.1 icu
    =dev-util/desktop-file-utils-0.23 emacs
    =media-fonts/urw-fonts-2.4.9 X
    =media-fonts/liberation-fonts-2.00.1-r3 X
    =media-fonts/dejavu-2.37 X
    =dev-lang/python-3.5.5 gdbm sqlite
    =dev-lang/python-3.5.5 sqlite
    =dev-lang/python-3.5.5 tk
    =virtual/libiconv-0-r2 abi_x86_32
    =sys-apps/groff-1.22.3 X

NOTE: The --binpkg-respect-use=n option will prevent emerge
      from ignoring these binary packages if possible.
      Using --binpkg-respect-use=y will silence this warning.

!!! The following binary packages have been ignored due to changed dependencies:

     dev-lang/python-3.5.5::gentoo

NOTE: The --binpkg-changed-deps=n option will prevent emerge
      from ignoring these binary packages if possible.
      Using --binpkg-changed-deps=y will silence this warning.
Comment 7 Zac Medico gentoo-dev 2019-06-10 03:06:01 UTC
(In reply to William Throwe from comment #6)
> Using --autounmask-backtrack=y instead of --autounmask-keep-masks also works.

The --autounmask-backtrack=y solution is an interesting find.
Comment 8 Zac Medico gentoo-dev 2019-09-06 21:20:11 UTC
We want to create --autounmask-backtrack=n exemptions for autounmask changes which are negated backtracking feedback (such as slot operator rebuilds).